# Python imports

# Lib imports

# Application imports



class TggleAndCheckBoxSignals:
    def on_reset_clicked(self, param):
        if self.selected_style_id in self.all_styles_dict:
            del self.all_styles_dict[self.selected_style_id]
            self.clear_and_disable_style_buttons()
            self.update_sample_view()

    def on_background_toggled(self, param):
        if param.get_active():
            self.br_color_btn.set_sensitive(True)
            self.br_color_btn.activate()
        else:
            self.br_color_btn.set_sensitive(False)
            self.all_styles_dict[self.selected_style_id].background = None;
            self.update_sample_view()

    def on_foreground_toggled(self, param):
        if param.get_active():
            self.fr_color_btn.set_sensitive(True)
            self.fr_color_btn.activate()
        else:
            self.fr_color_btn.set_sensitive(False)
            self.all_styles_dict[self.selected_style_id].foreground = None;
            self.update_sample_view()

    def clear_and_disable_style_buttons(self):
        self.fr_color_btn.set_color(self.black_color)
        self.br_color_btn.set_color(self.black_color)
        self.fr_color_btn.set_sensitive(False)
        self.fr_check_btn.set_active(False)
        self.br_color_btn.set_sensitive(False)
        self.br_check_btn.set_active(False)

        self.italic_tggle_btn.set_active(False)
        self.bold_tggle_btn.set_active(False)
        self.strikethrough_tggle_btn.set_active(False)
        self.underline_tggle_btn.set_active(False)

        self.reset_btn.set_sensitive(False)
